Bug 1027 - maemo-launcher does not install headers
: maemo-launcher does not install headers
Status: RESOLVED FIXED
Product: System software
maemo-launcher
: unspecified
: All Maemo
: Medium normal (vote)
: 4.0
Assigned To: Guillem Jover
: maemo-launcher-bugs
:
:
:
:
  Show dependency tree
 
Reported: 2007-02-06 18:53 UTC by Murray Cumming
Modified: 2008-12-06 16:52 UTC (History)
2 users (show)

See Also:


Attachments
Patch install headers and adds pkg-config file (2.48 KB, patch)
2007-02-28 21:36 UTC, Johannes Schmid
Details
Patch to add multi-booster support (8.04 KB, patch)
2007-03-04 20:19 UTC, Johannes Schmid
Details
Fixes pkg-config file in patch above (8.02 KB, patch)
2007-03-04 22:04 UTC, Johannes Schmid
Details
Add libdir to .pc file (734 bytes, patch)
2007-03-08 14:54 UTC, Johannes Schmid
Details


Note

You need to log in before you can comment on or make changes to this bug.


Description Murray Cumming (reporter) 2007-02-06 18:53:33 UTC
maemo-launcher does not install any headers. For  instance, there is no -dev
debian package. This makes it impossible to implement new booster modules
without adding them to maemo-launcher itself.

I can't find a really suitable bugzilla component for maemo-launcher, so please
reassign if necessary.
Comment 1 Tommi Komulainen nokia 2007-02-06 21:40:53 UTC
-> Guillem
Comment 2 Guillem Jover nokia 2007-02-14 18:22:58 UTC
(In reply to comment #0)
> maemo-launcher does not install any headers. For  instance, there is no -dev
> debian package. This makes it impossible to implement new booster modules
> without adding them to maemo-launcher itself.

When I added support for the modular boosters I had that in mind, but there
was no need at that point, and didn't want to expose the API yet. I've a .pc
and debheleper dh_maemo-launcher that could be included as well.

Would you need this soon, or is this a general wish?
Comment 3 Murray Cumming (reporter) 2007-02-14 19:03:57 UTC
Actually, yes, it would be very helpful to me if that was committed soon. I'd
like to make a gtkmm booster for a customer.
Comment 4 Murray Cumming (reporter) 2007-02-23 11:54:03 UTC
Hi. Has that been committed already?
Comment 5 Murray Cumming (reporter) 2007-02-28 15:47:17 UTC
This does not seem to have been committed? Do you need a patch?
Comment 6 Johannes Schmid 2007-02-28 21:36:26 UTC
Created an attachment (id=191) [details]
Patch install headers and adds pkg-config file

With this patch the public headers (report.h and booster.h) are installed to
{includedir}/maemo-launcher-1.0/maemo-launcher and a pkg-config file
(maemo-launcher-1.0.pc) is installed in the pkg-config path.

Please tell if there is anything that needs to be changed or if I should also
add a -dev debian package.
Comment 7 Guillem Jover nokia 2007-02-28 23:09:23 UTC
Hey guys,

Sorry for the delay, have been a bit busy lately.

(In reply to comment #6)
> Created an attachment (id=191) [details]
> Patch install headers and adds pkg-config file

Thanks for the patch, although it's a bit wrong. ;)
The .pc should not Require all those packages, those are specific to the
launcher no to the boosters. Anyway as I said I've .pc files around I'll
polish them tomorrow.

> With this patch the public headers (report.h and booster.h) are installed to
> {includedir}/maemo-launcher-1.0/maemo-launcher and a pkg-config file
> (maemo-launcher-1.0.pc) is installed in the pkg-config path.

Also I've been meaning to get rid of the report.h dependency from the
boosters, so that I can stop using -rdynamic on the launcher. And I'll have
to remove the booster_load_module from the header as I don't want to expose
that one.

> Please tell if there is anything that needs to be changed or if I should also
> add a -dev debian package.

It's a bit late now, so I'm heading home, but don't worry will take care of
the fixes and commit tomorrow.
Comment 8 Johannes Schmid 2007-03-01 18:18:25 UTC
> Also I've been meaning to get rid of the report.h dependency from the
> boosters, so that I can stop using -rdynamic on the launcher. And I'll have
> to remove the booster_load_module from the header as I don't want to expose
> that one.

Could you please keep booster_load_module? It could be very handy because as I
guess our gtkmm booster will be gtk booster + x and it would be nice if we could
load the gtk booster using booster_load_module and call its methods at the
beginning of our preinit/init/reload methods.
Comment 9 Guillem Jover nokia 2007-03-02 00:19:35 UTC
(In reply to comment #8)
> > Also I've been meaning to get rid of the report.h dependency from the
> > boosters, so that I can stop using -rdynamic on the launcher. And I'll have
> > to remove the booster_load_module from the header as I don't want to expose
> > that one.
> 
> Could you please keep booster_load_module? It could be very handy because
> as I guess our gtkmm booster will be gtk booster + x and it would be nice
> if we could load the gtk booster using booster_load_module and call its
> methods at the beginning of our preinit/init/reload methods.

Ah right, long time since I've been messing with the launcher. At the time I 
thought about extending the support to be able to load several boosters, but
in that case that would not take into account dependencies, no big deal if you 
sort them properly like "--booster gtk,gtkmm" or similar.

Thinking twice about this, my main concern is about exposing any kind of API, 
as then supposedly I'll have to go through our API process, and that might take 
time (just sent a mail now for confirmation). Also I found a non-commited
patch I wrote to select making the boosters builtin.

Another possibility would be to merge back your changes, and then create a 
separete binary package with the gtkmm booster, what about that?
Comment 10 Johannes Schmid 2007-03-02 11:41:24 UTC
> Ah right, long time since I've been messing with the launcher. At the time I 
> thought about extending the support to be able to load several boosters, but
> in that case that would not take into account dependencies, no big deal if you 
> sort them properly like "--booster gtk,gtkmm" or similar.

That would be a clean solution of course! At least because we already plan to
have a gtkmm and a maemomm booster and both will depend on the gtk booster.

> 
> Thinking twice about this, my main concern is about exposing any kind of API, 
> as then supposedly I'll have to go through our API process, and that might take 
> time (just sent a mail now for confirmation). Also I found a non-commited
> patch I wrote to select making the boosters builtin.
> 
> Another possibility would be to merge back your changes, and then create a 
> separete binary package with the gtkmm booster, what about that?

Well, I don't know about you API process but we need the gtkmm booster without
too much delay. I already created a package (depends on the patch) with a simple
gtkmm booster which does just call the gtk booster in the moment. You can have a
look at the sources here:
https://garage.maemo.org/plugins/scmsvn/viewcvs.php/trunk/gtkmm-booster/?root=maemomm
Comment 11 Murray Cumming (reporter) 2007-03-02 11:48:59 UTC
I guess we can just duplicate the gtk booster initialization in our gtkmm
booster if necessary, if we can't have the API to call the gtk booster from our
gtkmm booster.

For me, that's far preferrable than being part of the actual maemo-launcher
module. That would make us dependent on Nokia's internal processes in future,
just in order to avoid one of their internal processes now. That sounds
ungrateful, but I think it's practical. Thanks.
Comment 12 Johannes Schmid 2007-03-04 20:19:43 UTC
Created an attachment (id=195) [details]
Patch to add multi-booster support

This patch adds support for multiple booster if they a pass them sorted (like
"gtk,gtkmm" to the --booster argument.

Tested against a full af-sb-init start without problems.

The patch also contains a stripped down package file and does only install the
booster.h header. You also can savely remove booster_module_load now.
Comment 13 Johannes Schmid 2007-03-04 22:04:16 UTC
Created an attachment (id=196) [details]
Fixes pkg-config file in patch above

Sorry, the .pc file still contained requirements which are wrong because it
should simply require nothing as meamo-launcher is only linked against glibc.

The rest of the patch has not changed.
Comment 14 Guillem Jover nokia 2007-03-08 00:19:37 UTC
(In reply to comment #13)
> Created an attachment (id=196) [details]
> Fixes pkg-config file in patch above
> 
> Sorry, the .pc file still contained requirements which are wrong because it
> should simply require nothing as meamo-launcher is only linked against glibc.
> 
> The rest of the patch has not changed.

Hey, thanks again for the patch. Did some rewritting but it's now commited.
Tell me if everything is fine, and I'll poke again internally for the API
process thingy.
Comment 15 Murray Cumming (reporter) 2007-03-08 10:45:27 UTC
Thanks. Is this likely to get into the Maemo Bora release, or only into Bora+1?
Comment 16 Johannes Schmid 2007-03-08 14:54:43 UTC
Created an attachment (id=249) [details]
Add libdir to .pc file

Thanks for cleaning up the code. I have used glib for years so my plain C
knowledge is a bit limited.

This patch adds libdir to the pkg-config file which is necessary to install
additional launchers in the correct directory.
Comment 17 Guillem Jover nokia 2007-03-08 19:38:34 UTC
(In reply to comment #16)
> Thanks for cleaning up the code. I have used glib for years so my plain C
> knowledge is a bit limited.

No problem.

> This patch adds libdir to the pkg-config file which is necessary to install
> additional launchers in the correct directory.

Yeah thanks, I've added the proper variable and the needed ones, and changed 
the includedir one as well.

I'm exporting the api as C, so you can remove that from your code. I've cleared 
with the guys here that we don't need to go through the api process, as long as 
anything from the release is using it. That does not mean I'm not going to 
handle it properly, I've been thinking to export the api version in the .pc 
file so that it could be checked from the configure.ac for compatibility.
Comment 18 Guillem Jover nokia 2007-03-08 19:41:13 UTC
(In reply to comment #15)
> Thanks. Is this likely to get into the Maemo Bora release, or only into
> Bora+1?

Hmm I'll have to check with the sdk guys, I don't exactly know how to push 
updates to packages there. I'll post something when I get the info. For sardine 
I could ask Marius or Carlos to take the packages, but that will need the gtk 
2.10 fixes/workarounds and probably branching for now.
Comment 19 Carlos Guerreiro maemo.org 2007-03-08 22:01:27 UTC
The SDK goes in sync with the product. It's just another configuration of the 
same software. There's no separate path. 
However, whatever goes in Sardine will end up in the next major release of 
Maemo in both the product and then SDK.
Guillem, you are the maintainer of maemo-lancher, so it's up to you what and 
when to push of maemo-launcher to sardine. You can get help in the sardine-
developers mailing list about how.
Right now, we are transitioning to the new gtk/hildon in sardine-experimental 
so for the future it's more useful to apply patches there.
Comment 20 Murray Cumming (reporter) 2007-03-08 23:42:42 UTC
> but that will need the gtk 2.10 fixes/workarounds

By the way, if you already have a patch for this somewhere, we'd be interested.
Otherwise, we will try to fix that.


Carlos. Thanks, yes, this could be much clearer with a module list such as GNOME
has, so we know what branches are used for what.
Comment 21 Johannes Schmid 2007-03-09 11:57:32 UTC
I have created a booster module that works with 2.10 but does not use the
Display hacks. At least it does no crash with gtk 2.10. You need SVN TRUNK of
maemo-launcher to compile it.

Have a look:
https://garage.maemo.org/plugins/scmsvn/viewcvs.php/trunk/gtk2.10.booster/?root=maemomm
Comment 22 Johannes Schmid 2007-03-09 11:59:34 UTC
(In reply to comment #21)
Wrong bug, sorry was meant for #952
Comment 23 Johannes Schmid 2007-03-20 11:32:37 UTC
When will the new maemo-launcher (0.22) be availible for bora?

I ask because we need at least version 0.22 to be able to create a working
gtkmm-boster package.

Thanks!
Comment 24 Murray Cumming (reporter) 2007-04-16 16:27:56 UTC
Could we please have a new package, or some timeline for a new package, so we
can deploy the gktmm booster?
Comment 25 Murray Cumming (reporter) 2007-07-05 15:15:08 UTC
Please? This is frustrating.
Comment 26 Murray Cumming (reporter) 2007-07-16 13:21:38 UTC
OK, so I'm giving up on seeing this in Bora.

But what package in maemo sardine/Chinook has this .pc file and the header?
Comment 27 Guillem Jover nokia 2007-08-02 02:07:51 UTC
This has been fixed in 0.22-1.
Comment 28 Murray Cumming (reporter) 2007-08-28 20:05:42 UTC
Note to self: This is in the maemo-launcher-dev package.
Comment 29 Murray Cumming (reporter) 2007-10-28 11:31:24 UTC
maemo-launcher-dev does not seem to be in the chinook beta, though it is in
sardine.
Comment 30 Natalia Dobrovolskaya nokia 2007-10-30 17:54:22 UTC
(In reply to comment #29)
> maemo-launcher-dev does not seem to be in the chinook beta, though it is in
> sardine.
> 
You are right! Good point! I will check it and try to fix.
Comment 31 Murray Cumming (reporter) 2007-11-13 12:26:21 UTC
maemo-launcher-dev is in the Maemo Chinook SDK. Thank you.
Comment 32 Andre Klapper maemo.org 2008-12-06 13:19:13 UTC
(changing Version from "sardine" to "unspecified" for consistency with other
products)